﻿@page "/tasks/solutions/view/{TaskSolutionId:guid}"
@implements IDisposable

@using Sirkadirov.Overtest.SharedLibraries.ODataStoreLib.Models.TasksArchive
@using Microsoft.EntityFrameworkCore
@using Microsoft.Extensions.Localization
@using OWebApplication.Operators
@using System.Threading
@using System.Globalization
@using System.Text
@using ByteSizeLib
@using Overtest.SharedLibraries.ProgrammingTasksShared.VerificationResults

@inject AuthenticationStateProvider _authenticationStateProvider
@inject IDbContextFactory<OvertestDatabaseContext> _dbContextFactory
@inject IStringLocalizer<TasksArchive> _localizer
@inject NavigationManager _navigationManager
@inject UserAccessControlOperator _userAccessControlOperator
@inject UserManager<User> _userManager

@inject IDialogService _dialogService
@inject ISnackbar _snackbar

<style>
    pre {
        display: block;
        tab-size: 4;
        white-space: nowrap;
        overflow-x: auto;
        font-family: SFMono-Regular, Menlo, Monaco, Consolas, "Liberation Mono", "Courier New", monospace;
        user-select: all !important; -webkit-user-select: all !important;
        -moz-user-select: all !important; -ms-user-select: all !important;
    }
</style>

<MudContainer MaxWidth="MaxWidth.Medium" Class="my-3">
    <MudToolBar Class="px-0" Style="height: auto;">
        <MudContainer Class="ma-0 pa-0">
            <MudText Typo="Typo.h5" Class="mb-2" Style="font-weight: bold; line-height: 1;">@_localizer["Результати тестування"]</MudText>
            
            @if (_taskSolution is not null)
            {
                <MudButton Variant="Variant.Text" Size="Size.Small" Class="mr-2"
                           StartIcon="@Icons.Material.Filled.ChevronLeft"
                >@_localizer["Усі розв'язки"]</MudButton>
                <MudButton Variant="Variant.Text" Size="Size.Small" StartIcon="@Icons.Material.Filled.Wysiwyg"
                           OnClick="@(() => _navigationManager.NavigateTo($"/tasks/view/{_taskSolution.ProgrammingTaskId}"))"
                >@_localizer["Завдання"]</MudButton>
            }
        </MudContainer>
        <MudSpacer />
        @if (_currentUserIsCurator)
        {
            <MudIconButton OnClick="DeleteSolutionAsync" Icon="@Icons.Material.Outlined.DeleteForever" Color="Color.Error"></MudIconButton>
        }
    </MudToolBar>
</MudContainer>

<MudContainer MaxWidth="MaxWidth.Medium" Class="my-3">
    @if (_taskSolution is not null)
    {
        <MudTabs Outlined="true" Elevation="0" Rounded="true" ApplyEffectsToContainer="true" PanelClass="pa-3">
            <MudTabPanel Text="@_localizer["Оцінювання"]">
                @if (_taskSolution.VerificationStatus != TaskSolution.SolutionVerificationStatus.Verified)
                {
                    <MudPaper Outlined="false" Elevation="0" Class="pa-0 py-4 ma-0" Style="text-align: center;">
                        <MudProgressCircular Color="Color.Primary" Indeterminate="true"
                                             Style="width: 70px; height: 70px;"/>
                        <div class="d-flex justify-center align-center">
                            <MudText Class="mr-1" Typo="Typo.subtitle1" Style="font-weight: bold; line-height: 1;">@_localizer["Статус запиту:"]</MudText>
                            <MudChip Class="ml-1">@_taskSolution.VerificationStatus</MudChip>
                        </div>
                        <MudText Typo="Typo.subtitle1" Style="font-weight: normal; line-height: 1;">@_localizer["Виконується обробка розв'язку..."]</MudText>
                    </MudPaper>
                }
                else if (_taskSolutionVerificationResult is null)
                {
                    for (var i = 0; i < 3; i++)
                    {
                        <MudContainer Class="ma-0 pa-0 mb-3">
                            <MudSkeleton SkeletonType="SkeletonType.Rectangle" Width="150px" Height="32px" Class="ma-0 mb-3"/>
                            <MudSkeleton SkeletonType="SkeletonType.Rectangle" Width="100%" Height="250px" Class="ma-0"/>
                        </MudContainer>
                    }
                }
                else
                {
                    if (!string.IsNullOrWhiteSpace(_taskSolutionVerificationResult.ErrorMessage))
                    {
                        <MudContainer Class="ma-0 pa-0 mb-3">
                            <MudText Typo="Typo.h6" Class="mb-1">@_localizer["Помилка перевірки"]</MudText>
                            <MudAlert Severity="Severity.Error" Class="ma-0" Style="word-break: break-word !important;">
                                @_taskSolutionVerificationResult.ErrorMessage
                            </MudAlert>
                        </MudContainer>
                    }
                    
                    if (_taskSolutionVerificationResult.CompilationResult is not null)
                    {
                        <MudContainer Class="ma-0 pa-0 mb-3">
                            <MudContainer Class="ma-0 pa-0 mb-3 d-flex justify-space-between align-center">
                                <MudText Typo="Typo.h6">@_localizer["Компіляція розв'язку"]</MudText>
                                @if (_taskSolutionVerificationResult.CompilationResult.IsSuccessful)
                                {
                                    <MudChip Size="Size.Small" Icon="@Icons.Material.Filled.CheckCircle" Color="Color.Success">@_localizer["Успішно"]</MudChip>
                                }
                                else
                                {
                                    <MudChip Size="Size.Small" Icon="@Icons.Material.Filled.Error" Color="Color.Error">@_localizer["Помилка"]</MudChip>
                                }
                            </MudContainer>
                            <MudPaper Elevation="1" Class="pa-2" Style="background-color: #212121 !important; color: #ffffff !important;">
                                <pre class="ma-0 pa-0">@((MarkupString)_taskSolutionVerificationResult.CompilationResult.CompilationOutput
                                                           .Replace("<", "&lt;").Replace(">", "&gt;")
                                                           .Replace("&", "&amp;").Replace("\r", "")
                                                           .Replace("\n", "<br/>"))</pre>
                            </MudPaper>
                        </MudContainer>
                    }

                    if (_taskSolutionVerificationResult.TestResults?.Count > 0)
                    {
                        <MudContainer Class="ma-0 pa-0 mb-3">
                            <MudContainer Class="ma-0 pa-0 mb-3 d-flex justify-space-between align-center">
                                <MudText Typo="Typo.h6">@_localizer["Тестування програми"]</MudText>
                                @if (_taskSolutionVerificationResult.TestResults.All(r => r.Verdict == SingleTestVerdict.Successful))
                                {
                                    <MudChip Size="Size.Small" Icon="@Icons.Material.Filled.CheckCircle" Color="Color.Success">@_localizer["Успішно"]</MudChip>
                                }
                                else if (_taskSolutionVerificationResult.TestResults.Any(r => r.Verdict == SingleTestVerdict.Successful))
                                {
                                    <MudChip Size="Size.Small" Icon="@Icons.Material.Filled.CheckCircle" Color="Color.Warning">@_localizer["Частково"]</MudChip>
                                }
                                else
                                {
                                    <MudChip Size="Size.Small" Icon="@Icons.Material.Filled.Error" Color="Color.Error">@_localizer["Провалено"]</MudChip>
                                }
                            </MudContainer>
                            <MudTable Items="@_taskSolutionVerificationResult.TestResults" Outlined="true" Elevation="0"
                                      Hover="true" Breakpoint="Breakpoint.None" Dense="true" HorizontalScrollbar="true">
                                <HeaderContent>
                                    <MudTh>@_localizer["Назва тесту"]</MudTh>
                                    <MudTh Style="text-align: center; white-space: nowrap;">@_localizer["Процесорний час"]</MudTh>
                                    <MudTh Style="text-align: center; white-space: nowrap;">@_localizer["Робочий простір"]</MudTh>
                                    <MudTh Style="text-align: center; white-space: nowrap;">@_localizer["Час виконання"]</MudTh>
                                    <MudTh Style="text-align: center; white-space: nowrap;">@_localizer["Код виходу"]</MudTh>
                                    <MudTh Style="text-align: center; white-space: nowrap;">@_localizer["Вердикт"]</MudTh>
                                </HeaderContent>
                                <RowTemplate>
                                    <MudTd Style="white-space: nowrap;">@context.TestTitle</MudTd>
                                    <MudTd Style="text-align: center;">@_localizer["{0} мс / {1} мс", context.ProcessorTimeUsed, context.RuntimeLimits.MaxProcessorTime]</MudTd>
                                    <MudTd Style="text-align: center;">
                                        @_localizer["{0} МіБ / {1} МіБ", Math.Round(ByteSize.FromBits(context.WorkingSetUsed).MebiBytes, 2),
                                            Math.Round(ByteSize.FromBits(context.RuntimeLimits.PeakWorkingSet).MebiBytes, 2)]
                                    </MudTd>
                                    <MudTd Style="text-align: center;">@_localizer["{0} мс / {1} мс", context.RealExecutionTimeUsed, context.RuntimeLimits.MaxRealTime]</MudTd>
                                    <MudTd Style="text-align: center;">@context.ExitCode</MudTd>
                                    <MudTd Style="text-align: center;">
                                        @switch (context.Verdict)
                                        {
                                            case SingleTestVerdict.VerificationFailed:
                                                <MudChip Size="Size.Small" Color="Color.Error" Variant="Variant.Text"
                                                         title="@context.Verdict.ToString()">@_localizer["ERR"]</MudChip>
                                                break;
                                            case SingleTestVerdict.WrongOutputFormat:
                                                <MudChip Size="Size.Small" Color="Color.Error" Variant="Variant.Text"
                                                         title="@context.Verdict.ToString()">@_localizer["WOF"]</MudChip>
                                                break;
                                                
                                            case SingleTestVerdict.ProcessorTimeLimitReached:
                                                <MudChip Size="Size.Small" Color="Color.Error" Variant="Variant.Text"
                                                         title="@context.Verdict.ToString()">@_localizer["TL"]</MudChip>
                                                break;
                                            case SingleTestVerdict.WorkingSetLimitReached:
                                                <MudChip Size="Size.Small" Color="Color.Error" Variant="Variant.Text"
                                                         title="@context.Verdict.ToString()">@_localizer["ML"]</MudChip>
                                                break;
                                            case SingleTestVerdict.IdlingTimeout:
                                                <MudChip Size="Size.Small" Color="Color.Error" Variant="Variant.Text"
                                                         title="@context.Verdict.ToString()">@_localizer["IDL"]</MudChip>
                                                break;
                                            case SingleTestVerdict.RuntimeError:
                                                <MudChip Size="Size.Small" Color="Color.Error" Variant="Variant.Text"
                                                         title="@context.Verdict.ToString()">@_localizer["RE"]</MudChip>
                                                break;
                                                
                                            case SingleTestVerdict.WrongAnswer:
                                                <MudChip Size="Size.Small" Color="Color.Error" Variant="Variant.Text"
                                                         title="@context.Verdict.ToString()">@_localizer["WA"]</MudChip>
                                                break;
                                            case SingleTestVerdict.Successful:
                                                <MudChip Size="Size.Small" Color="Color.Success" Variant="Variant.Text"
                                                         title="@context.Verdict.ToString()">@_localizer["OK"]</MudChip>
                                                break;
                                            default:
                                                <MudChip Size="Size.Small" Color="Color.Error" Variant="Variant.Text"
                                                         title="@context.Verdict.ToString()">@_localizer["???"]</MudChip>
                                                break;
                                        }
                                    </MudTd>
                                </RowTemplate>
                            </MudTable>
                        </MudContainer>
                    }

                    if (_taskSolution.VerificationType == TaskSolution.SolutionVerificationType.ReleaseMode)
                    {
                        <MudContainer Class="ma-0 pa-0">
                            <MudContainer Class="ma-0 pa-0 mb-3 d-flex justify-space-between align-center">
                                <MudText Typo="Typo.h6">@_localizer["Оцінювання розв'язку"]</MudText>
                                @switch (_taskSolution.Adjudgement)
                                {
                                    case TaskSolution.SolutionAdjudgementType.ZeroSolution:
                                        <MudChip Size="Size.Small" Icon="@Icons.Material.Filled.Error"
                                                 Color="Color.Error">@_localizer["Відхилено"]</MudChip>
                                        break;
                                    case TaskSolution.SolutionAdjudgementType.PartialSolution:
                                        <MudChip Size="Size.Small" Icon="@Icons.Material.Filled.CheckCircle"
                                                 Color="Color.Warning">@_localizer["Частково"]</MudChip>
                                        break;
                                    case TaskSolution.SolutionAdjudgementType.CompleteSolution:
                                        <MudChip Size="Size.Small" Icon="@Icons.Material.Filled.CheckCircle"
                                                 Color="Color.Success">@_localizer["Успішно"]</MudChip>
                                        break;
                                }
                            </MudContainer>
                            <MudPaper Outlined="true" Elevation="0" Class="ma-0 pa-0">
                                <MudList Dense="true" Clickable="true">
                                    <MudListItem Icon="@Icons.Material.Outlined.Checklist">
                                        @((MarkupString)(_localizer["Даний розв'язок до завдання успішно пройшов <strong>{0}</strong> тестів з <strong>{1}</strong>",
                                            _taskSolutionVerificationResult.TestResults.Count(r => r.Verdict == SingleTestVerdict.Successful),
                                            _taskSolutionVerificationResult.TestResults.Count].Value))
                                    </MudListItem>
                                    <MudListItem Icon="@Icons.Material.Outlined.EmojiEvents">
                                        @((MarkupString)(_localizer["За розв'язання цього завдання отримано <strong>{0}</strong> балів з <strong>{1}</strong> можливих",
                                            _taskSolution.GivenRating,
                                            _taskSolution.ProgrammingTask.Difficulty].Value))
                                    </MudListItem>
                                </MudList>
                            </MudPaper>
                        </MudContainer>
                    }
                }
            </MudTabPanel>
            <MudTabPanel Text="@_localizer["Розв'язок"]">
                <MudPaper Elevation="1" Class="pa-2" Style="background-color: #212121 !important; color: #ffffff !important;">
                    <pre class="ma-0 pa-0">@((MarkupString)_taskSolution.SourceCode
                                               .Replace("<", "&lt;").Replace(">", "&gt;")
                                               .Replace("&", "&amp;").Replace("\r", "")
                                               .Replace("\n", "<br/>"))</pre>
                </MudPaper>
                <MudText Class="mt-3"><strong>@_localizer["Компілятор:"]</strong> @_taskSolution.Compiler.Title</MudText>
            </MudTabPanel>
            <MudTabPanel Text="@_localizer["Інформація"]">
                <MudList Clickable="true" Class="ma-n3">
                    <MudListItem OnClick="@(() => _navigationManager.NavigateTo($"/users/profile/{_taskSolution.AuthorId}"))">
                        <MudText Typo="Typo.subtitle1" Style="font-weight: bold; line-height: 1.4;">@_localizer["Автор розв'язку:"]</MudText>
                        <MudText Typo="Typo.body1" Style="line-height: 1.4;">@_taskSolution.Author.FullName</MudText>
                    </MudListItem>
                
                    <MudListItem OnClick="@(() => _navigationManager.NavigateTo($"/tasks/view/{_taskSolution.ProgrammingTaskId}"))">
                        <MudText Typo="Typo.subtitle1" Style="font-weight: bold; line-height: 1.4;">@_localizer["Завдання:"]</MudText>
                        <MudText Typo="Typo.body1" Style="line-height: 1.4;">@_taskSolution.ProgrammingTask.Title</MudText>
                    </MudListItem>
                                    
                    <MudDivider/>
                    
                    <MudListItem>
                        <MudText Typo="Typo.subtitle1" Style="font-weight: bold; line-height: 1.4;">@_localizer["Ідентифікатор розв'язку:"]</MudText>
                        <MudText Typo="Typo.body1" Style="line-height: 1.4;">@_taskSolution.Id</MudText>
                    </MudListItem>
                    
                    <MudListItem>
                        <MudText Typo="Typo.subtitle1" Style="font-weight: bold; line-height: 1.4;">@_localizer["Тип тестування:"]</MudText>
                        <MudText Typo="Typo.body1" Style="line-height: 1.4;">@_taskSolution.VerificationType.ToString()</MudText>
                    </MudListItem>

                    <MudDivider/>
                                    
                    <MudListItem>
                        <MudText Typo="Typo.subtitle1" Style="font-weight: bold; line-height: 1.4;">@_localizer["Відправлено на опрацювання:"]</MudText>
                        <MudText Typo="Typo.body1" Style="line-height: 1.4;">@_taskSolution.Created.ToString(CultureInfo.InvariantCulture)</MudText>
                    </MudListItem>
                                    
                    @if (_taskSolution.ProcessingTime != TimeSpan.Zero)
                    {
                    <MudListItem>
                        <MudText Typo="Typo.subtitle1" Style="font-weight: bold; line-height: 1.4;">@_localizer["Період опрацювання:"]</MudText>
                        <MudText Typo="Typo.body1" Style="line-height: 1.4;">@_taskSolution.ProcessingTime.ToString()</MudText>
                    </MudListItem>
                    }
                </MudList>
            </MudTabPanel>
        </MudTabs>
    }
    else
    {
        <MudSkeleton SkeletonType="SkeletonType.Rectangle" Width="100%" Height="500px"/>
    }
</MudContainer>

@code {
    private readonly CancellationTokenSource _cancellationTokenSource = new();
    
    [Parameter] public Guid TaskSolutionId { get; set; }

    private Guid _currentUserId;
    private bool _currentUserIsCurator;
    
    private TaskSolution _taskSolution;
    private TaskSolutionVerificationResult _taskSolutionVerificationResult;
    
    protected override async Task OnInitializedAsync()
    {
        await base.OnInitializedAsync();

        _currentUserId = await GetCurrentUserIdAsync();
        _currentUserIsCurator = false;

        _taskSolution = null;
        _taskSolutionVerificationResult = null;

        async Task<Guid> GetCurrentUserIdAsync()
        {
            var authState = await _authenticationStateProvider.GetAuthenticationStateAsync();
            return new Guid(_userManager.GetUserId(authState.User));
        }
    }
    
    protected override async Task OnParametersSetAsync()
    {
        await base.OnParametersSetAsync();
        
        await using var databaseContext = _dbContextFactory.CreateDbContext();

        if (!await databaseContext.ProgrammingTaskSolutions.AnyAsync(s => s.Id == TaskSolutionId))
        {
            _snackbar.Add(_localizer["Розв'язку до завдання зі вказаним ідентифікатором не знайдено!"],
                Severity.Error, options => options.CloseAfterNavigation = false);
            _navigationManager.NavigateTo("/tasks/solutions/list");
            return;
        }

        var solutionAuthorId = await databaseContext.ProgrammingTaskSolutions
            .Where(s => s.Id == TaskSolutionId)
            .Select(s => s.AuthorId)
            .FirstAsync();

        if (!await _userAccessControlOperator.HasEditPrivillegesAsync(databaseContext,
            _currentUserId, solutionAuthorId))
        {
            _snackbar.Add(_localizer["Ви не маєте необхідних прав доступу для перегляду цієї сторінки!"],
                Severity.Error, options => options.CloseAfterNavigation = false);
            _navigationManager.NavigateTo("/tasks/solutions/list");
            return;
        }
        
        _currentUserIsCurator = await _userAccessControlOperator.HasUserTypeAsync(databaseContext,
            _currentUserId, UserType.Curator, UserType.SuperUser);

        await FetchTaskSolutionDataAsync(databaseContext);
        StateHasChanged();
        
        try { await WaitForVerificationResultsAsync(); }
        catch (Exception) { /* Ignore all exceptions */ }
    }

    private async Task WaitForVerificationResultsAsync()
    {
        if (_cancellationTokenSource.IsCancellationRequested)
            return;
        if (_taskSolution.VerificationStatus == TaskSolution.SolutionVerificationStatus.Verified)
            return;

        await using var databaseContext = _dbContextFactory.CreateDbContext();

        while (_taskSolution.VerificationStatus != TaskSolution.SolutionVerificationStatus.Verified)
        {
            if (_cancellationTokenSource.IsCancellationRequested)
                return;
            
            await Task.Delay(1000);
            
            var newVerificationStatus = await GetCurrentVerificationStatusAsync(databaseContext);

            if (_taskSolution.VerificationStatus == newVerificationStatus)
                continue;
            
            if (newVerificationStatus == TaskSolution.SolutionVerificationStatus.Verified)
                await FetchTaskSolutionDataAsync(databaseContext);

            _taskSolution.VerificationStatus = newVerificationStatus;
            StateHasChanged();
        }
    }
    
    private async Task FetchTaskSolutionDataAsync(OvertestDatabaseContext databaseContext)
    {
        _taskSolution = await databaseContext.ProgrammingTaskSolutions
            .Include(i => i.Author)
            .Include(i => i.ProgrammingTask)
            .Include(i => i.Compiler)
            .Where(s => s.Id == TaskSolutionId)
            .Select(s => new TaskSolution
            {
                Id = s.Id, Created = s.Created, ProcessingTime = s.ProcessingTime,
                SourceCode = s.SourceCode, VerificationType = s.VerificationType,
                VerificationStatus = s.VerificationStatus, RawVerificationResult = s.RawVerificationResult,
                Adjudgement = s.Adjudgement, GivenRating = s.GivenRating,
                
                AuthorId = s.AuthorId,
                Author = new User { FullName = s.Author.FullName },
                
                ProgrammingTaskId = s.ProgrammingTaskId,
                ProgrammingTask = new ProgrammingTask { Title = s.ProgrammingTask.Title, Difficulty = s.ProgrammingTask.Difficulty },
                
                CompilerId = s.CompilerId,
                Compiler = new Compiler { Title = s.Compiler.Title, SyntaxHighlighter = s.Compiler.SyntaxHighlighter }
            })
            .AsNoTracking().FirstAsync();

        if (_taskSolution.VerificationStatus == TaskSolution.SolutionVerificationStatus.Verified && _taskSolution.RawVerificationResult is not null)
        {
            try
            {
                _taskSolutionVerificationResult = TaskSolutionVerificationResult
                    .FromJson(Encoding.UTF8.GetString(_taskSolution.RawVerificationResult));
                return;
            }
            catch (Exception) { /* Ignore all exceptions */ }
        }
        _taskSolutionVerificationResult = null;
    }

    private async Task<TaskSolution.SolutionVerificationStatus>
        GetCurrentVerificationStatusAsync(OvertestDatabaseContext databaseContext)
    {
        return await databaseContext.ProgrammingTaskSolutions
            .Where(s => s.Id == TaskSolutionId)
            .Select(s => s.VerificationStatus)
            .FirstAsync();
    }
    
    void IDisposable.Dispose()
    {
        _cancellationTokenSource.Cancel();
        _cancellationTokenSource.Dispose();
    }

    private async Task DeleteSolutionAsync()
    {
        if (!_currentUserIsCurator)
            return;
        
        await using var databaseContext = _dbContextFactory.CreateDbContext();

        var isDeletionAllowed = _taskSolution.VerificationStatus == TaskSolution.SolutionVerificationStatus.Verified ||
                                await _userAccessControlOperator.HasUserTypeAsync(databaseContext,
                                    _currentUserId, UserType.SuperUser);

        if (!isDeletionAllowed)
        {
            _snackbar.Add(_localizer[
                "Поточний статус оцінювання розв'язку не дає можливості його видалити. " +
                "Зачекайте завершення процесу оцінювання або зв'яжіться з адміністратором системи."], Severity.Error);
            return;
        }

        var confirmation = await _dialogService.ShowMessageBox(new MessageBoxOptions
        {
            Title = _localizer["Видалення розв'язку"],
            Message = _localizer["Ви впевнені у тому, що хочете видалити цей розв'язок? Ця дія є безповоротньою!"],
            YesText = _localizer["Підтвердити"], NoText = _localizer["Скасувати"], CancelText = null
        }, new DialogOptions
        {
            CloseButton = false, DisableBackdropClick = true,
            MaxWidth = MaxWidth.Small, FullWidth = true,
            Position = DialogPosition.Center
        });
        
        if (confirmation is not true)
            return;

        try
        {
            var dbObject = await databaseContext.ProgrammingTaskSolutions
                .Where(s => s.Id == TaskSolutionId)
                .Select(s => new TaskSolution { Id = s.Id, VerificationStatus = s.VerificationStatus })
                .FirstAsync();
            databaseContext.ProgrammingTaskSolutions.Remove(dbObject);
            await databaseContext.SaveChangesAsync();
            
            _snackbar.Add(_localizer["Розв'язок успішно видалено!"], Severity.Success,
                options => options.CloseAfterNavigation = false);

            // TODO: Redirect to author's submissions list
            _navigationManager.NavigateTo($"/tasks/view/{_taskSolution.ProgrammingTaskId}");
        }
        catch (Exception)
        {
            _snackbar.Add(_localizer["Нам не вдалося видалити цей розв'язок! Можливо, статус його верифікації щойно змінився."],
                Severity.Error, options => options.CloseAfterNavigation = false);
            StateHasChanged();
        }
    }
}